package com.eurodyn.ecdp.taric.validation.rules;

import gr.eurodyn.isee.rule.RuleExecutionResult;
import com.eurodyn.ecdp.taric.validation.utils.*;
import com.eurodyn.ecdp.taric.validation.implementation.*;
import java.util.List;
 import com.eurodyn.ecdp.taric.services.FtnoteAssocAddCodeService;
           import com.eurodyn.ecdp.taric.hyperjaxb.entities.AdditionalCode;
          

/**
  * <p>
  * @version $Revision$
  * $Id$
  */
public class ACN16 extends WrapperRule {

     @Override
     public RuleExecutionResult fire() {
          FtnoteAssocAddCodeService varFtnoteAssocAddCodeService = null;
         AdditionalCode varAdditionalCode = null;
        
         boolean hasParams = true;
         for (Object o : this.getRp().getBagOfObjects()) {
            
             if (o instanceof FtnoteAssocAddCodeService) {
                 varFtnoteAssocAddCodeService = (FtnoteAssocAddCodeService) o;
             }
              
             if (o instanceof AdditionalCode) {
                 varAdditionalCode = (AdditionalCode) o;
             }
             
         }
          hasParams = hasParams && (varFtnoteAssocAddCodeService == null);
         hasParams = hasParams && (varAdditionalCode == null);
        
         if (!hasParams) {
           return null;
         }

         RuleExecutionResult rer = new RuleExecutionResult();
         try {
           ACN16_impl rule_ACN16 = new ACN16_impl();
           rer = rule_ACN16.evaluate(varFtnoteAssocAddCodeService,varAdditionalCode);
         } catch (Exception e) {
           rer.setRuleSatisfied(false);
           Logger.getLogger(ACN16.class.getName()).log(Level.SEVERE, null, e);
         } catch (Throwable t) {
           rer.setRuleSatisfied(false);
           Logger.getLogger(ACN16.class.getName()).log(Level.SEVERE, null, t);
         }
        
         }
         return rer;
     }
}
