package com.eurodyn.ecdp.taric.validation.rules;

import gr.eurodyn.isee.rule.RuleExecutionResult;
import com.eurodyn.ecdp.taric.validation.utils.*;
import com.eurodyn.ecdp.taric.validation.implementation.*;
import java.util.List;
 import com.eurodyn.ecdp.taric.services.AddCodeTypeService;
           import com.eurodyn.ecdp.taric.hyperjaxb.entities.AdditionalCode;
          

/**
  * <p>
  * @version $Revision$
  * $Id$
  */
public class ACN17 extends WrapperRule {

     @Override
     public RuleExecutionResult fire() {
          AddCodeTypeService varAddCodeTypeService = null;
         AdditionalCode varAdditionalCode = null;
        
         boolean hasParams = true;
         for (Object o : this.getRp().getBagOfObjects()) {
            
             if (o instanceof AddCodeTypeService) {
                 varAddCodeTypeService = (AddCodeTypeService) o;
             }
              
             if (o instanceof AdditionalCode) {
                 varAdditionalCode = (AdditionalCode) o;
             }
             
         }
          hasParams = hasParams && (varAddCodeTypeService == null);
         hasParams = hasParams && (varAdditionalCode == null);
        
         if (!hasParams) {
           return null;
         }

         RuleExecutionResult rer = new RuleExecutionResult();
         try {
           ACN17_impl rule_ACN17 = new ACN17_impl();
           rer = rule_ACN17.evaluate(varAddCodeTypeService,varAdditionalCode);
         } catch (Exception e) {
           rer.setRuleSatisfied(false);
           Logger.getLogger(ACN17.class.getName()).log(Level.SEVERE, null, e);
         } catch (Throwable t) {
           rer.setRuleSatisfied(false);
           Logger.getLogger(ACN17.class.getName()).log(Level.SEVERE, null, t);
         }
        
         }
         return rer;
     }
}
