package com.eurodyn.ecdp.taric.validation.rules;

import gr.eurodyn.isee.rule.RuleExecutionResult;
import com.eurodyn.ecdp.taric.validation.utils.*;
import com.eurodyn.ecdp.taric.validation.implementation.*;
import java.util.List;
 import com.eurodyn.ecdp.taric.services.MeasureTypeService;
           import com.eurodyn.ecdp.taric.hyperjaxb.entities.AdditionalCodeTypeMeasureType;
          

/**
  * <p>
  * @version $Revision$
  * $Id$
  */
public class AMT1 extends WrapperRule {

     @Override
     public RuleExecutionResult fire() {
          MeasureTypeService varMeasureTypeService = null;
         AdditionalCodeTypeMeasureType varAdditionalCodeTypeMeasureType = null;
        
         boolean hasParams = true;
         for (Object o : this.getRp().getBagOfObjects()) {
            
             if (o instanceof MeasureTypeService) {
                 varMeasureTypeService = (MeasureTypeService) o;
             }
              
             if (o instanceof AdditionalCodeTypeMeasureType) {
                 varAdditionalCodeTypeMeasureType = (AdditionalCodeTypeMeasureType) o;
             }
             
         }
          hasParams = hasParams && (varMeasureTypeService == null);
         hasParams = hasParams && (varAdditionalCodeTypeMeasureType == null);
        
         if (!hasParams) {
           return null;
         }

         RuleExecutionResult rer = new RuleExecutionResult();
         try {
           AMT1_impl rule_AMT1 = new AMT1_impl();
           rer = rule_AMT1.evaluate(varMeasureTypeService,varAdditionalCodeTypeMeasureType);
         } catch (Exception e) {
           rer.setRuleSatisfied(false);
           Logger.getLogger(AMT1.class.getName()).log(Level.SEVERE, null, e);
         } catch (Throwable t) {
           rer.setRuleSatisfied(false);
           Logger.getLogger(AMT1.class.getName()).log(Level.SEVERE, null, t);
         }
        
         }
         return rer;
     }
}
