package com.eurodyn.ecdp.taric.validation.rules;

import gr.eurodyn.isee.rule.RuleExecutionResult;
import com.eurodyn.ecdp.taric.validation.utils.*;
import com.eurodyn.ecdp.taric.validation.implementation.*;
import java.util.List;
 import com.eurodyn.ecdp.taric.services.AdditionalCodeService;
           import com.eurodyn.ecdp.taric.hyperjaxb.entities.AdditionalCodeTypeMeasureType;
          

/**
  * <p>
  * @version $Revision$
  * $Id$
  */
public class AMT7 extends WrapperRule {

     @Override
     public RuleExecutionResult fire() {
          AdditionalCodeService varAdditionalCodeService = null;
         AdditionalCodeTypeMeasureType varAdditionalCodeTypeMeasureType = null;
        
         boolean hasParams = true;
         for (Object o : this.getRp().getBagOfObjects()) {
            
             if (o instanceof AdditionalCodeService) {
                 varAdditionalCodeService = (AdditionalCodeService) o;
             }
              
             if (o instanceof AdditionalCodeTypeMeasureType) {
                 varAdditionalCodeTypeMeasureType = (AdditionalCodeTypeMeasureType) o;
             }
             
         }
          hasParams = hasParams && (varAdditionalCodeService == null);
         hasParams = hasParams && (varAdditionalCodeTypeMeasureType == null);
        
         if (!hasParams) {
           return null;
         }

         RuleExecutionResult rer = new RuleExecutionResult();
         try {
           AMT7_impl rule_AMT7 = new AMT7_impl();
           rer = rule_AMT7.evaluate(varAdditionalCodeService,varAdditionalCodeTypeMeasureType);
         } catch (Exception e) {
           rer.setRuleSatisfied(false);
           Logger.getLogger(AMT7.class.getName()).log(Level.SEVERE, null, e);
         } catch (Throwable t) {
           rer.setRuleSatisfied(false);
           Logger.getLogger(AMT7.class.getName()).log(Level.SEVERE, null, t);
         }
        
         }
         return rer;
     }
}
