package com.eurodyn.ecdp.taric.validation.rules;

import gr.eurodyn.isee.rule.RuleExecutionResult;
import com.eurodyn.ecdp.taric.validation.utils.*;
import com.eurodyn.ecdp.taric.validation.implementation.*;
import java.util.List;
 import com.eurodyn.ecdp.taric.services.MeasureTypeService;
           import com.eurodyn.ecdp.taric.hyperjaxb.entities.AdditionalCodeType;
          

/**
  * <p>
  * @version $Revision$
  * $Id$
  */
public class CT10 extends WrapperRule {

     @Override
     public RuleExecutionResult fire() {
          MeasureTypeService varMeasureTypeService = null;
         AdditionalCodeType varAdditionalCodeType = null;
        
         boolean hasParams = true;
         for (Object o : this.getRp().getBagOfObjects()) {
            
             if (o instanceof MeasureTypeService) {
                 varMeasureTypeService = (MeasureTypeService) o;
             }
              
             if (o instanceof AdditionalCodeType) {
                 varAdditionalCodeType = (AdditionalCodeType) o;
             }
             
         }
          hasParams = hasParams && (varMeasureTypeService == null);
         hasParams = hasParams && (varAdditionalCodeType == null);
        
         if (!hasParams) {
           return null;
         }

         RuleExecutionResult rer = new RuleExecutionResult();
         try {
           CT10_impl rule_CT10 = new CT10_impl();
           rer = rule_CT10.evaluate(varMeasureTypeService,varAdditionalCodeType);
         } catch (Exception e) {
           rer.setRuleSatisfied(false);
           Logger.getLogger(CT10.class.getName()).log(Level.SEVERE, null, e);
         } catch (Throwable t) {
           rer.setRuleSatisfied(false);
           Logger.getLogger(CT10.class.getName()).log(Level.SEVERE, null, t);
         }
        
         }
         return rer;
     }
}
