package com.eurodyn.ecdp.taric.validation.rules;

import gr.eurodyn.isee.rule.RuleExecutionResult;
import com.eurodyn.ecdp.taric.validation.utils.*;
import com.eurodyn.ecdp.taric.validation.implementation.*;
import java.util.List;
 import com.eurodyn.ecdp.taric.services.MeursingTablePlanService;
           import com.eurodyn.ecdp.taric.hyperjaxb.entities.AdditionalCodeType;
          

/**
  * <p>
  * @version $Revision$
  * $Id$
  */
public class CT7 extends WrapperRule {

     @Override
     public RuleExecutionResult fire() {
          MeursingTablePlanService varMeursingTablePlanService = null;
         AdditionalCodeType varAdditionalCodeType = null;
        
         boolean hasParams = true;
         for (Object o : this.getRp().getBagOfObjects()) {
            
             if (o instanceof MeursingTablePlanService) {
                 varMeursingTablePlanService = (MeursingTablePlanService) o;
             }
              
             if (o instanceof AdditionalCodeType) {
                 varAdditionalCodeType = (AdditionalCodeType) o;
             }
             
         }
          hasParams = hasParams && (varMeursingTablePlanService == null);
         hasParams = hasParams && (varAdditionalCodeType == null);
        
         if (!hasParams) {
           return null;
         }

         RuleExecutionResult rer = new RuleExecutionResult();
         try {
           CT7_impl rule_CT7 = new CT7_impl();
           rer = rule_CT7.evaluate(varMeursingTablePlanService,varAdditionalCodeType);
         } catch (Exception e) {
           rer.setRuleSatisfied(false);
           Logger.getLogger(CT7.class.getName()).log(Level.SEVERE, null, e);
         } catch (Throwable t) {
           rer.setRuleSatisfied(false);
           Logger.getLogger(CT7.class.getName()).log(Level.SEVERE, null, t);
         }
        
         }
         return rer;
     }
}
