package com.eurodyn.ecdp.taric.validation.rules;

import gr.eurodyn.isee.rule.RuleExecutionResult;
import com.eurodyn.ecdp.taric.validation.utils.*;
import com.eurodyn.ecdp.taric.validation.implementation.*;
import java.util.List;
 import com.eurodyn.ecdp.taric.services.ExportRefNomService;
           import com.eurodyn.ecdp.taric.hyperjaxb.entities.AdditionalCodeType;
          

/**
  * <p>
  * @version $Revision$
  * $Id$
  */
public class CT9 extends WrapperRule {

     @Override
     public RuleExecutionResult fire() {
          ExportRefNomService varExportRefNomService = null;
         AdditionalCodeType varAdditionalCodeType = null;
        
         boolean hasParams = true;
         for (Object o : this.getRp().getBagOfObjects()) {
            
             if (o instanceof ExportRefNomService) {
                 varExportRefNomService = (ExportRefNomService) o;
             }
              
             if (o instanceof AdditionalCodeType) {
                 varAdditionalCodeType = (AdditionalCodeType) o;
             }
             
         }
          hasParams = hasParams && (varExportRefNomService == null);
         hasParams = hasParams && (varAdditionalCodeType == null);
        
         if (!hasParams) {
           return null;
         }

         RuleExecutionResult rer = new RuleExecutionResult();
         try {
           CT9_impl rule_CT9 = new CT9_impl();
           rer = rule_CT9.evaluate(varExportRefNomService,varAdditionalCodeType);
         } catch (Exception e) {
           rer.setRuleSatisfied(false);
           Logger.getLogger(CT9.class.getName()).log(Level.SEVERE, null, e);
         } catch (Throwable t) {
           rer.setRuleSatisfied(false);
           Logger.getLogger(CT9.class.getName()).log(Level.SEVERE, null, t);
         }
        
         }
         return rer;
     }
}
