package com.eurodyn.ecdp.taric.validation.rules;

import gr.eurodyn.isee.rule.RuleExecutionResult;
import com.eurodyn.ecdp.taric.validation.utils.*;
import com.eurodyn.ecdp.taric.validation.implementation.*;
import java.util.List;
 import com.eurodyn.ecdp.taric.services.MeasureService;
           import com.eurodyn.ecdp.taric.hyperjaxb.entities.DutyExpression;
          

/**
  * <p>
  * @version $Revision$
  * $Id$
  */
public class DE4 extends WrapperRule {

     @Override
     public RuleExecutionResult fire() {
          MeasureService varMeasureService = null;
         DutyExpression varDutyExpression = null;
        
         boolean hasParams = true;
         for (Object o : this.getRp().getBagOfObjects()) {
            
             if (o instanceof MeasureService) {
                 varMeasureService = (MeasureService) o;
             }
              
             if (o instanceof DutyExpression) {
                 varDutyExpression = (DutyExpression) o;
             }
             
         }
          hasParams = hasParams && (varMeasureService == null);
         hasParams = hasParams && (varDutyExpression == null);
        
         if (!hasParams) {
           return null;
         }

         RuleExecutionResult rer = new RuleExecutionResult();
         try {
           DE4_impl rule_DE4 = new DE4_impl();
           rer = rule_DE4.evaluate(varMeasureService,varDutyExpression);
         } catch (Exception e) {
           rer.setRuleSatisfied(false);
           Logger.getLogger(DE4.class.getName()).log(Level.SEVERE, null, e);
         } catch (Throwable t) {
           rer.setRuleSatisfied(false);
           Logger.getLogger(DE4.class.getName()).log(Level.SEVERE, null, t);
         }
        
         }
         return rer;
     }
}
