package com.eurodyn.ecdp.taric.validation.rules;

import gr.eurodyn.isee.rule.RuleExecutionResult;
import com.eurodyn.ecdp.taric.validation.utils.*;
import com.eurodyn.ecdp.taric.validation.implementation.*;
import java.util.List;
 import com.eurodyn.ecdp.taric.services.MeursingHeadingFootnotesAssocService;
           import com.eurodyn.ecdp.taric.hyperjaxb.entities.Footnote;
          

/**
  * <p>
  * @version $Revision$
  * $Id$
  */
public class FO10 extends WrapperRule {

     @Override
     public RuleExecutionResult fire() {
          MeursingHeadingFootnotesAssocService varMeursingHeadingFootnotesAssocService = null;
         Footnote varFootnote = null;
        
         boolean hasParams = true;
         for (Object o : this.getRp().getBagOfObjects()) {
            
             if (o instanceof MeursingHeadingFootnotesAssocService) {
                 varMeursingHeadingFootnotesAssocService = (MeursingHeadingFootnotesAssocService) o;
             }
              
             if (o instanceof Footnote) {
                 varFootnote = (Footnote) o;
             }
             
         }
          hasParams = hasParams && (varMeursingHeadingFootnotesAssocService == null);
         hasParams = hasParams && (varFootnote == null);
        
         if (!hasParams) {
           return null;
         }

         RuleExecutionResult rer = new RuleExecutionResult();
         try {
           FO10_impl rule_FO10 = new FO10_impl();
           rer = rule_FO10.evaluate(varMeursingHeadingFootnotesAssocService,varFootnote);
         } catch (Exception e) {
           rer.setRuleSatisfied(false);
           Logger.getLogger(FO10.class.getName()).log(Level.SEVERE, null, e);
         } catch (Throwable t) {
           rer.setRuleSatisfied(false);
           Logger.getLogger(FO10.class.getName()).log(Level.SEVERE, null, t);
         }
        
         }
         return rer;
     }
}
