package com.eurodyn.ecdp.taric.validation.rules;

import gr.eurodyn.isee.rule.RuleExecutionResult;
import com.eurodyn.ecdp.taric.validation.utils.*;
import com.eurodyn.ecdp.taric.validation.implementation.*;
import java.util.List;
 import com.eurodyn.ecdp.taric.hyperjaxb.entities.ExportRefundNomenclature;
           import com.eurodyn.ecdp.taric.hyperjaxb.entities.Footnote;
          

/**
  * <p>
  * @version $Revision$
  * $Id$
  */
public class FO13 extends WrapperRule {

     @Override
     public RuleExecutionResult fire() {
          ExportRefundNomenclature varExportRefundNomenclature = null;
         Footnote varFootnote = null;
        
         boolean hasParams = true;
         for (Object o : this.getRp().getBagOfObjects()) {
            
             if (o instanceof ExportRefundNomenclature) {
                 varExportRefundNomenclature = (ExportRefundNomenclature) o;
             }
              
             if (o instanceof Footnote) {
                 varFootnote = (Footnote) o;
             }
             
         }
          hasParams = hasParams && (varExportRefundNomenclature == null);
         hasParams = hasParams && (varFootnote == null);
        
         if (!hasParams) {
           return null;
         }

         RuleExecutionResult rer = new RuleExecutionResult();
         try {
           FO13_impl rule_FO13 = new FO13_impl();
           rer = rule_FO13.evaluate(varExportRefundNomenclature,varFootnote);
         } catch (Exception e) {
           rer.setRuleSatisfied(false);
           Logger.getLogger(FO13.class.getName()).log(Level.SEVERE, null, e);
         } catch (Throwable t) {
           rer.setRuleSatisfied(false);
           Logger.getLogger(FO13.class.getName()).log(Level.SEVERE, null, t);
         }
        
         }
         return rer;
     }
}
