package com.eurodyn.ecdp.taric.validation.rules;

import gr.eurodyn.isee.rule.RuleExecutionResult;
import com.eurodyn.ecdp.taric.validation.utils.*;
import com.eurodyn.ecdp.taric.validation.implementation.*;
import java.util.List;
 import com.eurodyn.ecdp.taric.services.GoodsNomenclatureService;
           import com.eurodyn.ecdp.taric.hyperjaxb.entities.Footnote;
          

/**
  * <p>
  * @version $Revision$
  * $Id$
  */
public class FO6 extends WrapperRule {

     @Override
     public RuleExecutionResult fire() {
          GoodsNomenclatureService varGoodsNomenclatureService = null;
         Footnote varFootnote = null;
        
         boolean hasParams = true;
         for (Object o : this.getRp().getBagOfObjects()) {
            
             if (o instanceof GoodsNomenclatureService) {
                 varGoodsNomenclatureService = (GoodsNomenclatureService) o;
             }
              
             if (o instanceof Footnote) {
                 varFootnote = (Footnote) o;
             }
             
         }
          hasParams = hasParams && (varGoodsNomenclatureService == null);
         hasParams = hasParams && (varFootnote == null);
        
         if (!hasParams) {
           return null;
         }

         RuleExecutionResult rer = new RuleExecutionResult();
         try {
           FO6_impl rule_FO6 = new FO6_impl();
           rer = rule_FO6.evaluate(varGoodsNomenclatureService,varFootnote);
         } catch (Exception e) {
           rer.setRuleSatisfied(false);
           Logger.getLogger(FO6.class.getName()).log(Level.SEVERE, null, e);
         } catch (Throwable t) {
           rer.setRuleSatisfied(false);
           Logger.getLogger(FO6.class.getName()).log(Level.SEVERE, null, t);
         }
        
         }
         return rer;
     }
}
