package com.eurodyn.ecdp.taric.validation.rules;

import gr.eurodyn.isee.rule.RuleExecutionResult;
import com.eurodyn.ecdp.taric.validation.utils.*;
import com.eurodyn.ecdp.taric.validation.implementation.*;
import java.util.List;
 import com.eurodyn.ecdp.taric.hyperjaxb.entities.AdditionalCodeservice;
           import com.eurodyn.ecdp.taric.hyperjaxb.entities.Footnote;
          

/**
  * <p>
  * @version $Revision$
  * $Id$
  */
public class FO9 extends WrapperRule {

     @Override
     public RuleExecutionResult fire() {
          AdditionalCodeservice varAdditionalCodeservice = null;
         Footnote varFootnote = null;
        
         boolean hasParams = true;
         for (Object o : this.getRp().getBagOfObjects()) {
            
             if (o instanceof AdditionalCodeservice) {
                 varAdditionalCodeservice = (AdditionalCodeservice) o;
             }
              
             if (o instanceof Footnote) {
                 varFootnote = (Footnote) o;
             }
             
         }
          hasParams = hasParams && (varAdditionalCodeservice == null);
         hasParams = hasParams && (varFootnote == null);
        
         if (!hasParams) {
           return null;
         }

         RuleExecutionResult rer = new RuleExecutionResult();
         try {
           FO9_impl rule_FO9 = new FO9_impl();
           rer = rule_FO9.evaluate(varAdditionalCodeservice,varFootnote);
         } catch (Exception e) {
           rer.setRuleSatisfied(false);
           Logger.getLogger(FO9.class.getName()).log(Level.SEVERE, null, e);
         } catch (Throwable t) {
           rer.setRuleSatisfied(false);
           Logger.getLogger(FO9.class.getName()).log(Level.SEVERE, null, t);
         }
        
         }
         return rer;
     }
}
