package com.eurodyn.ecdp.taric.validation.rules;

import gr.eurodyn.isee.rule.RuleExecutionResult;
import com.eurodyn.ecdp.taric.validation.utils.*;
import com.eurodyn.ecdp.taric.validation.implementation.*;
import java.util.List;
 import com.eurodyn.ecdp.taric.services.GeoAreaService;
           import com.eurodyn.ecdp.taric.hyperjaxb.entities.GeographicalArea;
          

/**
  * <p>
  * @version $Revision$
  * $Id$
  */
public class GA1 extends WrapperRule {

     @Override
     public RuleExecutionResult fire() {
          GeoAreaService varGeoAreaService = null;
         GeographicalArea varGeographicalArea = null;
        
         boolean hasParams = true;
         for (Object o : this.getRp().getBagOfObjects()) {
            
             if (o instanceof GeoAreaService) {
                 varGeoAreaService = (GeoAreaService) o;
             }
              
             if (o instanceof GeographicalArea) {
                 varGeographicalArea = (GeographicalArea) o;
             }
             
         }
          hasParams = hasParams && (varGeoAreaService == null);
         hasParams = hasParams && (varGeographicalArea == null);
        
         if (!hasParams) {
           return null;
         }

         RuleExecutionResult rer = new RuleExecutionResult();
         try {
           GA1_impl rule_GA1 = new GA1_impl();
           rer = rule_GA1.evaluate(varGeoAreaService,varGeographicalArea);
         } catch (Exception e) {
           rer.setRuleSatisfied(false);
           Logger.getLogger(GA1.class.getName()).log(Level.SEVERE, null, e);
         } catch (Throwable t) {
           rer.setRuleSatisfied(false);
           Logger.getLogger(GA1.class.getName()).log(Level.SEVERE, null, t);
         }
        
         }
         return rer;
     }
}
