package com.eurodyn.ecdp.taric.validation.rules;

import gr.eurodyn.isee.rule.RuleExecutionResult;
import com.eurodyn.ecdp.taric.validation.utils.*;
import com.eurodyn.ecdp.taric.validation.implementation.*;
import java.util.List;
 import com.eurodyn.ecdp.taric.services.MeasureService;
           import com.eurodyn.ecdp.taric.hyperjaxb.entities.GeographicalArea;
          

/**
  * <p>
  * @version $Revision$
  * $Id$
  */
public class GA10 extends WrapperRule {

     @Override
     public RuleExecutionResult fire() {
          MeasureService varMeasureService = null;
         GeographicalArea varGeographicalArea = null;
        
         boolean hasParams = true;
         for (Object o : this.getRp().getBagOfObjects()) {
            
             if (o instanceof MeasureService) {
                 varMeasureService = (MeasureService) o;
             }
              
             if (o instanceof GeographicalArea) {
                 varGeographicalArea = (GeographicalArea) o;
             }
             
         }
          hasParams = hasParams && (varMeasureService == null);
         hasParams = hasParams && (varGeographicalArea == null);
        
         if (!hasParams) {
           return null;
         }

         RuleExecutionResult rer = new RuleExecutionResult();
         try {
           GA10_impl rule_GA10 = new GA10_impl();
           rer = rule_GA10.evaluate(varMeasureService,varGeographicalArea);
         } catch (Exception e) {
           rer.setRuleSatisfied(false);
           Logger.getLogger(GA10.class.getName()).log(Level.SEVERE, null, e);
         } catch (Throwable t) {
           rer.setRuleSatisfied(false);
           Logger.getLogger(GA10.class.getName()).log(Level.SEVERE, null, t);
         }
        
         }
         return rer;
     }
}
