package com.eurodyn.ecdp.taric.validation.rules;

import gr.eurodyn.isee.rule.RuleExecutionResult;
import com.eurodyn.ecdp.taric.validation.utils.*;
import com.eurodyn.ecdp.taric.validation.implementation.*;
import java.util.List;
 import com.eurodyn.ecdp.taric.services.GeographicalAreaMembershipService;
           import com.eurodyn.ecdp.taric.services.MeasureExlGeoAreaService;
           import com.eurodyn.ecdp.taric.hyperjaxb.entities.GeographicalArea;
          

/**
  * <p>
  * @version $Revision$
  * $Id$
  */
public class GA23 extends WrapperRule {

     @Override
     public RuleExecutionResult fire() {
          GeographicalAreaMembershipService varGeographicalAreaMembershipService = null;
         MeasureExlGeoAreaService varMeasureExlGeoAreaService = null;
         GeographicalArea varGeographicalArea = null;
        
         boolean hasParams = true;
         for (Object o : this.getRp().getBagOfObjects()) {
            
             if (o instanceof GeographicalAreaMembershipService) {
                 varGeographicalAreaMembershipService = (GeographicalAreaMembershipService) o;
             }
              
             if (o instanceof MeasureExlGeoAreaService) {
                 varMeasureExlGeoAreaService = (MeasureExlGeoAreaService) o;
             }
              
             if (o instanceof GeographicalArea) {
                 varGeographicalArea = (GeographicalArea) o;
             }
             
         }
          hasParams = hasParams && (varGeographicalAreaMembershipService == null);
         hasParams = hasParams && (varMeasureExlGeoAreaService == null);
         hasParams = hasParams && (varGeographicalArea == null);
        
         if (!hasParams) {
           return null;
         }

         RuleExecutionResult rer = new RuleExecutionResult();
         try {
           GA23_impl rule_GA23 = new GA23_impl();
           rer = rule_GA23.evaluate(varGeographicalAreaMembershipService,varMeasureExlGeoAreaService,varGeographicalArea);
         } catch (Exception e) {
           rer.setRuleSatisfied(false);
           Logger.getLogger(GA23.class.getName()).log(Level.SEVERE, null, e);
         } catch (Throwable t) {
           rer.setRuleSatisfied(false);
           Logger.getLogger(GA23.class.getName()).log(Level.SEVERE, null, t);
         }
        
         }
         return rer;
     }
}
