package com.eurodyn.ecdp.taric.validation.rules;

import gr.eurodyn.isee.rule.RuleExecutionResult;
import com.eurodyn.ecdp.taric.validation.utils.*;
import com.eurodyn.ecdp.taric.validation.implementation.*;
import java.util.List;
 import com.eurodyn.ecdp.taric.services.MeasureService;
           import com.eurodyn.ecdp.taric.hyperjaxb.entities.MonetaryUnit;
          

/**
  * <p>
  * @version $Revision$
  * $Id$
  */
public class MOU3 extends WrapperRule {

     @Override
     public RuleExecutionResult fire() {
          MeasureService varMeasureService = null;
         MonetaryUnit varMonetaryUnit = null;
        
         boolean hasParams = true;
         for (Object o : this.getRp().getBagOfObjects()) {
            
             if (o instanceof MeasureService) {
                 varMeasureService = (MeasureService) o;
             }
              
             if (o instanceof MonetaryUnit) {
                 varMonetaryUnit = (MonetaryUnit) o;
             }
             
         }
          hasParams = hasParams && (varMeasureService == null);
         hasParams = hasParams && (varMonetaryUnit == null);
        
         if (!hasParams) {
           return null;
         }

         RuleExecutionResult rer = new RuleExecutionResult();
         try {
           MOU3_impl rule_MOU3 = new MOU3_impl();
           rer = rule_MOU3.evaluate(varMeasureService,varMonetaryUnit);
         } catch (Exception e) {
           rer.setRuleSatisfied(false);
           Logger.getLogger(MOU3.class.getName()).log(Level.SEVERE, null, e);
         } catch (Throwable t) {
           rer.setRuleSatisfied(false);
           Logger.getLogger(MOU3.class.getName()).log(Level.SEVERE, null, t);
         }
        
         }
         return rer;
     }
}
