package com.eurodyn.ecdp.taric.validation.rules;

import gr.eurodyn.isee.rule.RuleExecutionResult;
import com.eurodyn.ecdp.taric.validation.utils.*;
import com.eurodyn.ecdp.taric.validation.implementation.*;
import java.util.List;
 import com.eurodyn.ecdp.taric.services.MonetaryExchangePeriodService;
           import com.eurodyn.ecdp.taric.services.MonetaryExchangeRateService;
           import com.eurodyn.ecdp.taric.hyperjaxb.entities.MonetaryUnit;
          

/**
  * <p>
  * @version $Revision$
  * $Id$
  */
public class MOU6 extends WrapperRule {

     @Override
     public RuleExecutionResult fire() {
          MonetaryExchangePeriodService varMonetaryExchangePeriodService = null;
         MonetaryExchangeRateService varMonetaryExchangeRateService = null;
         MonetaryUnit varMonetaryUnit = null;
        
         boolean hasParams = true;
         for (Object o : this.getRp().getBagOfObjects()) {
            
             if (o instanceof MonetaryExchangePeriodService) {
                 varMonetaryExchangePeriodService = (MonetaryExchangePeriodService) o;
             }
              
             if (o instanceof MonetaryExchangeRateService) {
                 varMonetaryExchangeRateService = (MonetaryExchangeRateService) o;
             }
              
             if (o instanceof MonetaryUnit) {
                 varMonetaryUnit = (MonetaryUnit) o;
             }
             
         }
          hasParams = hasParams && (varMonetaryExchangePeriodService == null);
         hasParams = hasParams && (varMonetaryExchangeRateService == null);
         hasParams = hasParams && (varMonetaryUnit == null);
        
         if (!hasParams) {
           return null;
         }

         RuleExecutionResult rer = new RuleExecutionResult();
         try {
           MOU6_impl rule_MOU6 = new MOU6_impl();
           rer = rule_MOU6.evaluate(varMonetaryExchangePeriodService,varMonetaryExchangeRateService,varMonetaryUnit);
         } catch (Exception e) {
           rer.setRuleSatisfied(false);
           Logger.getLogger(MOU6.class.getName()).log(Level.SEVERE, null, e);
         } catch (Throwable t) {
           rer.setRuleSatisfied(false);
           Logger.getLogger(MOU6.class.getName()).log(Level.SEVERE, null, t);
         }
        
         }
         return rer;
     }
}
