package com.eurodyn.ecdp.taric.validation.rules;

import gr.eurodyn.isee.rule.RuleExecutionResult;
import com.eurodyn.ecdp.taric.validation.utils.*;
import com.eurodyn.ecdp.taric.validation.implementation.*;
import java.util.List;
 import com.eurodyn.ecdp.taric.services.MeasureService;
           import com.eurodyn.ecdp.taric.hyperjaxb.entities.MeasurementUnitQualifier;
          

/**
  * <p>
  * @version $Revision$
  * $Id$
  */
public class MUQ4 extends WrapperRule {

     @Override
     public RuleExecutionResult fire() {
          MeasureService varMeasureService = null;
         MeasurementUnitQualifier varMeasurementUnitQualifier = null;
        
         boolean hasParams = true;
         for (Object o : this.getRp().getBagOfObjects()) {
            
             if (o instanceof MeasureService) {
                 varMeasureService = (MeasureService) o;
             }
              
             if (o instanceof MeasurementUnitQualifier) {
                 varMeasurementUnitQualifier = (MeasurementUnitQualifier) o;
             }
             
         }
          hasParams = hasParams && (varMeasureService == null);
         hasParams = hasParams && (varMeasurementUnitQualifier == null);
        
         if (!hasParams) {
           return null;
         }

         RuleExecutionResult rer = new RuleExecutionResult();
         try {
           MUQ4_impl rule_MUQ4 = new MUQ4_impl();
           rer = rule_MUQ4.evaluate(varMeasureService,varMeasurementUnitQualifier);
         } catch (Exception e) {
           rer.setRuleSatisfied(false);
           Logger.getLogger(MUQ4.class.getName()).log(Level.SEVERE, null, e);
         } catch (Throwable t) {
           rer.setRuleSatisfied(false);
           Logger.getLogger(MUQ4.class.getName()).log(Level.SEVERE, null, t);
         }
        
         }
         return rer;
     }
}
