package com.eurodyn.ecdp.taric.validation.rules;

import gr.eurodyn.isee.rule.RuleExecutionResult;
import com.eurodyn.ecdp.taric.validation.utils.*;
import com.eurodyn.ecdp.taric.validation.implementation.*;
import java.util.List;
 import com.eurodyn.ecdp.taric.services.MeasurementUnitService;
           import com.eurodyn.ecdp.taric.hyperjaxb.entities.MeasurementUnitQualifier;
          

/**
  * <p>
  * @version $Revision$
  * $Id$
  */
public class MUQ5 extends WrapperRule {

     @Override
     public RuleExecutionResult fire() {
          MeasurementUnitService varMeasurementUnitService = null;
         MeasurementUnitQualifier varMeasurementUnitQualifier = null;
        
         boolean hasParams = true;
         for (Object o : this.getRp().getBagOfObjects()) {
            
             if (o instanceof MeasurementUnitService) {
                 varMeasurementUnitService = (MeasurementUnitService) o;
             }
              
             if (o instanceof MeasurementUnitQualifier) {
                 varMeasurementUnitQualifier = (MeasurementUnitQualifier) o;
             }
             
         }
          hasParams = hasParams && (varMeasurementUnitService == null);
         hasParams = hasParams && (varMeasurementUnitQualifier == null);
        
         if (!hasParams) {
           return null;
         }

         RuleExecutionResult rer = new RuleExecutionResult();
         try {
           MUQ5_impl rule_MUQ5 = new MUQ5_impl();
           rer = rule_MUQ5.evaluate(varMeasurementUnitService,varMeasurementUnitQualifier);
         } catch (Exception e) {
           rer.setRuleSatisfied(false);
           Logger.getLogger(MUQ5.class.getName()).log(Level.SEVERE, null, e);
         } catch (Throwable t) {
           rer.setRuleSatisfied(false);
           Logger.getLogger(MUQ5.class.getName()).log(Level.SEVERE, null, t);
         }
        
         }
         return rer;
     }
}
