package com.eurodyn.ecdp.taric.validation.rules;

import gr.eurodyn.isee.rule.RuleExecutionResult;
import com.eurodyn.ecdp.taric.validation.utils.*;
import com.eurodyn.ecdp.taric.validation.implementation.*;
import java.util.List;
 import com.eurodyn.ecdp.taric.services.BaseRegulService;
           import com.eurodyn.ecdp.taric.hyperjaxb.entities.CompleteAbrogationRegulation;
          

/**
  * <p>
  * @version $Revision$
  * $Id$
  */
public class ROAC13 extends WrapperRule {

     @Override
     public RuleExecutionResult fire() {
          BaseRegulService varBaseRegulService = null;
         CompleteAbrogationRegulation varCompleteAbrogationRegulation = null;
        
         boolean hasParams = true;
         for (Object o : this.getRp().getBagOfObjects()) {
            
             if (o instanceof BaseRegulService) {
                 varBaseRegulService = (BaseRegulService) o;
             }
              
             if (o instanceof CompleteAbrogationRegulation) {
                 varCompleteAbrogationRegulation = (CompleteAbrogationRegulation) o;
             }
             
         }
          hasParams = hasParams && (varBaseRegulService == null);
         hasParams = hasParams && (varCompleteAbrogationRegulation == null);
        
         if (!hasParams) {
           return null;
         }

         RuleExecutionResult rer = new RuleExecutionResult();
         try {
           ROAC13_impl rule_ROAC13 = new ROAC13_impl();
           rer = rule_ROAC13.evaluate(varBaseRegulService,varCompleteAbrogationRegulation);
         } catch (Exception e) {
           rer.setRuleSatisfied(false);
           Logger.getLogger(ROAC13.class.getName()).log(Level.SEVERE, null, e);
         } catch (Throwable t) {
           rer.setRuleSatisfied(false);
           Logger.getLogger(ROAC13.class.getName()).log(Level.SEVERE, null, t);
         }
        
         }
         return rer;
     }
}
