package com.eurodyn.ecdp.taric.validation.rules;

import gr.eurodyn.isee.rule.RuleExecutionResult;
import com.eurodyn.ecdp.taric.validation.utils.*;
import com.eurodyn.ecdp.taric.validation.implementation.*;
import java.util.List;
 import com.eurodyn.ecdp.taric.services.BaseRegulService;
           import com.eurodyn.ecdp.taric.hyperjaxb.entities.ExplicitAbrogationRegulation;
          

/**
  * <p>
  * @version $Revision$
  * $Id$
  */
public class ROAE3 extends WrapperRule {

     @Override
     public RuleExecutionResult fire() {
          BaseRegulService varBaseRegulService = null;
         ExplicitAbrogationRegulation varExplicitAbrogationRegulation = null;
        
         boolean hasParams = true;
         for (Object o : this.getRp().getBagOfObjects()) {
            
             if (o instanceof BaseRegulService) {
                 varBaseRegulService = (BaseRegulService) o;
             }
              
             if (o instanceof ExplicitAbrogationRegulation) {
                 varExplicitAbrogationRegulation = (ExplicitAbrogationRegulation) o;
             }
             
         }
          hasParams = hasParams && (varBaseRegulService == null);
         hasParams = hasParams && (varExplicitAbrogationRegulation == null);
        
         if (!hasParams) {
           return null;
         }

         RuleExecutionResult rer = new RuleExecutionResult();
         try {
           ROAE3_impl rule_ROAE3 = new ROAE3_impl();
           rer = rule_ROAE3.evaluate(varBaseRegulService,varExplicitAbrogationRegulation);
         } catch (Exception e) {
           rer.setRuleSatisfied(false);
           Logger.getLogger(ROAE3.class.getName()).log(Level.SEVERE, null, e);
         } catch (Throwable t) {
           rer.setRuleSatisfied(false);
           Logger.getLogger(ROAE3.class.getName()).log(Level.SEVERE, null, t);
         }
        
         }
         return rer;
     }
}
