package com.eurodyn.ecdp.taric.validation.rules;

import gr.eurodyn.isee.rule.RuleExecutionResult;
import com.eurodyn.ecdp.taric.validation.utils.*;
import com.eurodyn.ecdp.taric.validation.implementation.*;
import java.util.List;
 import com.eurodyn.ecdp.taric.services.ExplicitAbrogRegService;
           import com.eurodyn.ecdp.taric.hyperjaxb.entities.BaseRegulation;
          

/**
  * <p>
  * @version $Revision$
  * $Id$
  */
public class ROIMB6 extends WrapperRule {

     @Override
     public RuleExecutionResult fire() {
          ExplicitAbrogRegService varExplicitAbrogRegService = null;
         BaseRegulation varBaseRegulation = null;
        
         boolean hasParams = true;
         for (Object o : this.getRp().getBagOfObjects()) {
            
             if (o instanceof ExplicitAbrogRegService) {
                 varExplicitAbrogRegService = (ExplicitAbrogRegService) o;
             }
              
             if (o instanceof BaseRegulation) {
                 varBaseRegulation = (BaseRegulation) o;
             }
             
         }
          hasParams = hasParams && (varExplicitAbrogRegService == null);
         hasParams = hasParams && (varBaseRegulation == null);
        
         if (!hasParams) {
           return null;
         }

         RuleExecutionResult rer = new RuleExecutionResult();
         try {
           ROIMB6_impl rule_ROIMB6 = new ROIMB6_impl();
           rer = rule_ROIMB6.evaluate(varExplicitAbrogRegService,varBaseRegulation);
         } catch (Exception e) {
           rer.setRuleSatisfied(false);
           Logger.getLogger(ROIMB6.class.getName()).log(Level.SEVERE, null, e);
         } catch (Throwable t) {
           rer.setRuleSatisfied(false);
           Logger.getLogger(ROIMB6.class.getName()).log(Level.SEVERE, null, t);
         }
        
         }
         return rer;
     }
}
