package com.eurodyn.ecdp.taric.validation.rules;

import gr.eurodyn.isee.rule.RuleExecutionResult;
import com.eurodyn.ecdp.taric.validation.utils.*;
import com.eurodyn.ecdp.taric.validation.implementation.*;
import java.util.List;
 import com.eurodyn.ecdp.taric.services.BaseRegulService;
           import com.eurodyn.ecdp.taric.hyperjaxb.entities.RegulationRoleType;
          

/**
  * <p>
  * @version $Revision$
  * $Id$
  */
public class RT2 extends WrapperRule {

     @Override
     public RuleExecutionResult fire() {
          BaseRegulService varBaseRegulService = null;
         RegulationRoleType varRegulationRoleType = null;
        
         boolean hasParams = true;
         for (Object o : this.getRp().getBagOfObjects()) {
            
             if (o instanceof BaseRegulService) {
                 varBaseRegulService = (BaseRegulService) o;
             }
              
             if (o instanceof RegulationRoleType) {
                 varRegulationRoleType = (RegulationRoleType) o;
             }
             
         }
          hasParams = hasParams && (varBaseRegulService == null);
         hasParams = hasParams && (varRegulationRoleType == null);
        
         if (!hasParams) {
           return null;
         }

         RuleExecutionResult rer = new RuleExecutionResult();
         try {
           RT2_impl rule_RT2 = new RT2_impl();
           rer = rule_RT2.evaluate(varBaseRegulService,varRegulationRoleType);
         } catch (Exception e) {
           rer.setRuleSatisfied(false);
           Logger.getLogger(RT2.class.getName()).log(Level.SEVERE, null, e);
         } catch (Throwable t) {
           rer.setRuleSatisfied(false);
           Logger.getLogger(RT2.class.getName()).log(Level.SEVERE, null, t);
         }
        
         }
         return rer;
     }
}
